<div class="uk-card uk-card-default uk-card-body uk-margin-top uk-margin-bottom">
  <h3 class="uk-card-title"></h3>
  <form [formGroup]="myForm">
    <div class="uk-margin">
      <label class="uk-form-label" for="text">Text</label>
      <div class="uk-form-controls">
        <textarea id="text" class="uk-textarea" placeholder="Example text 123" formControlName="text"></textarea>
      </div>
    </div>
    <div class="uk-margin">
      <label class="uk-form-label" for="key_a">A Key (coprime {{alphabet.size}})</label>
      <div class="uk-form-controls uk-flex">
        <input [class.uk-form-danger]="myForm.hasError('coprime')" type="number" id="key_a" class="uk-textarea" placeholder="123" formControlName="key_a">
        <a class="uk-button uk-button-primary uk-flex uk-flex-center uk-flex-middle" (click)="generateRandomKey()">Random</a>
      </div>
      <label class="uk-form-label uk-text-danger uk-text-small" *ngIf="myForm.hasError('coprime')" for="key_a">Value is not coprime with {{alphabet.size}}</label>
    </div>
    <div class="uk-margin">
      <label class="uk-form-label" for="key_b">B Key</label>
      <div class="uk-form-controls">
        <input type="number" id="key_b" class="uk-textarea" placeholder="321" formControlName="key_b"/>
      </div>
    </div>
    <div class="uk-margin">
      <a class="uk-button uk-button-primary" (click)="encrypt()">Encode <span uk-icon="lock"></span></a>
      <a class="uk-button uk-button-secondary" (click)="decrypt()">Decode <span uk-icon="unlock"></span></a>
    </div>
    <h2 class="uk-margin-top">
      Alphabet config <span uk-icon="cog"></span>
    </h2>
    <div class="uk-margin uk-grid-small" uk-grid>
      <div class="uk-display-flex">
        <div class="uk-margin">
          <label class="uk-form-label uk-flex" for="char">Letter</label>
          <div class="uk-form-controls uk-flex">
            <input class="uk-input" id="char" type="input" placeholder="Value" formControlName="char">
            <a class="uk-button uk-button-default uk-margin-left" *ngIf="char.valid" (click)="add(char.value)">Add</a>
          </div>
        </div>
      </div>
    </div>
  </form>
  <div class="uk-margin">
    <table class="uk-table uk-table-justify uk-table-divider">
      <thead>
      <tr>
        <th class="uk-width-small">Key</th>
        <th></th>
      </tr>
      </thead>
      <tbody>
      <tr *ngFor="let item of alphabet">
        <td>{{_.escape(item)}}</td>
        <td><a *ngIf="alphabet.size > 1" class="uk-button uk-button-default" (click)="alphabet.delete(item)">Remove</a></td>
      </tr>
      </tbody>
    </table>
  </div>
</div>
